CfnScraper L1 construct
A scraper is a fully-managed agentless collector that discovers and pulls metrics automatically.
A scraper pulls metrics from Prometheus-compatible sources within an Amazon EKS cluster, and sends them to your Amazon Managed Service for Prometheus workspace. Scrapers are flexible. You can configure the scraper to control what metrics are collected, the frequency of collection, what transformations are applied to the metrics, and more.
An IAM role will be created for you that Amazon Managed Service for Prometheus uses to access the metrics in your cluster. You must configure this role with a policy that allows it to scrape metrics from your cluster. For more information, see Configuring your Amazon EKS cluster in the Amazon Managed Service for Prometheus User Guide .
The scrapeConfiguration parameter contains the YAML configuration for the scraper.
For more information about collectors, including what metrics are collected, and how to configure the scraper, see Using an AWS managed collector in the Amazon Managed Service for Prometheus User Guide .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_aps as aps } from 'aws-cdk-lib';
const cfnScraper = new aps.CfnScraper(this, 'MyCfnScraper', {
destination: {
ampConfiguration: {
workspaceArn: 'workspaceArn',
},
cloudWatchConfiguration: {
datasetArn: 'datasetArn',
},
},
scrapeConfiguration: {
configurationBlob: 'configurationBlob',
},
source: {
eksConfiguration: {
clusterArn: 'clusterArn',
subnetIds: ['subnetIds'],
// the properties below are optional
securityGroupIds: ['securityGroupIds'],
},
vpcConfiguration: {
securityGroupIds: ['securityGroupIds'],
subnetIds: ['subnetIds'],
},
},
// the properties below are optional
alias: 'alias',
roleConfiguration: {
sourceRoleArn: 'sourceRoleArn',
targetRoleArn: 'targetRoleArn',
},
scraperLoggingConfiguration: {
loggingDestination: {
cloudWatchLogs: {
logGroupArn: 'logGroupArn',
},
},
scraperComponents: [{
type: 'type',
// the properties below are optional
config: {
options: {
optionsKey: 'options',
},
},
}],
},
tags: [{
key: 'key',
value: 'value',
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_aps as aps
cfn_scraper = aps.CfnScraper(self, "MyCfnScraper",
destination=aps.CfnScraper.DestinationProperty(
amp_configuration=aps.CfnScraper.AmpConfigurationProperty(
workspace_arn="workspaceArn"
),
cloud_watch_configuration=aps.CfnScraper.CloudWatchConfigurationProperty(
dataset_arn="datasetArn"
)
),
scrape_configuration=aps.CfnScraper.ScrapeConfigurationProperty(
configuration_blob="configurationBlob"
),
source=aps.CfnScraper.SourceProperty(
eks_configuration=aps.CfnScraper.EksConfigurationProperty(
cluster_arn="clusterArn",
subnet_ids=["subnetIds"],
# the properties below are optional
security_group_ids=["securityGroupIds"]
),
vpc_configuration=aps.CfnScraper.VpcConfigurationProperty(
security_group_ids=["securityGroupIds"],
subnet_ids=["subnetIds"]
)
),
# the properties below are optional
alias="alias",
role_configuration=aps.CfnScraper.RoleConfigurationProperty(
source_role_arn="sourceRoleArn",
target_role_arn="targetRoleArn"
),
scraper_logging_configuration=aps.CfnScraper.ScraperLoggingConfigurationProperty(
logging_destination=aps.CfnScraper.ScraperLoggingDestinationProperty(
cloud_watch_logs=aps.CfnScraper.CloudWatchLogDestinationProperty(
log_group_arn="logGroupArn"
)
),
scraper_components=[aps.CfnScraper.ScraperComponentProperty(
type="type",
# the properties below are optional
config=aps.CfnScraper.ComponentConfigProperty(
options={
"options_key": "options"
}
)
)]
),
tags=[CfnTag(
key="key",
value="value"
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.aps.*;
CfnScraper cfnScraper = CfnScraper.Builder.create(this, "MyCfnScraper")
.destination(DestinationProperty.builder()
.ampConfiguration(AmpConfigurationProperty.builder()
.workspaceArn("workspaceArn")
.build())
.cloudWatchConfiguration(CloudWatchConfigurationProperty.builder()
.datasetArn("datasetArn")
.build())
.build())
.scrapeConfiguration(ScrapeConfigurationProperty.builder()
.configurationBlob("configurationBlob")
.build())
.source(SourceProperty.builder()
.eksConfiguration(EksConfigurationProperty.builder()
.clusterArn("clusterArn")
.subnetIds(List.of("subnetIds"))
// the properties below are optional
.securityGroupIds(List.of("securityGroupIds"))
.build())
.vpcConfiguration(VpcConfigurationProperty.builder()
.securityGroupIds(List.of("securityGroupIds"))
.subnetIds(List.of("subnetIds"))
.build())
.build())
// the properties below are optional
.alias("alias")
.roleConfiguration(RoleConfigurationProperty.builder()
.sourceRoleArn("sourceRoleArn")
.targetRoleArn("targetRoleArn")
.build())
.scraperLoggingConfiguration(ScraperLoggingConfigurationProperty.builder()
.loggingDestination(ScraperLoggingDestinationProperty.builder()
.cloudWatchLogs(CloudWatchLogDestinationProperty.builder()
.logGroupArn("logGroupArn")
.build())
.build())
.scraperComponents(List.of(ScraperComponentProperty.builder()
.type("type")
// the properties below are optional
.config(ComponentConfigProperty.builder()
.options(Map.of(
"optionsKey", "options"))
.build())
.build()))
.build())
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.APS;
var cfnScraper = new CfnScraper(this, "MyCfnScraper", new CfnScraperProps {
Destination = new DestinationProperty {
AmpConfiguration = new AmpConfigurationProperty {
WorkspaceArn = "workspaceArn"
},
CloudWatchConfiguration = new CloudWatchConfigurationProperty {
DatasetArn = "datasetArn"
}
},
ScrapeConfiguration = new ScrapeConfigurationProperty {
ConfigurationBlob = "configurationBlob"
},
Source = new SourceProperty {
EksConfiguration = new EksConfigurationProperty {
ClusterArn = "clusterArn",
SubnetIds = new [] { "subnetIds" },
// the properties below are optional
SecurityGroupIds = new [] { "securityGroupIds" }
},
VpcConfiguration = new VpcConfigurationProperty {
SecurityGroupIds = new [] { "securityGroupIds" },
SubnetIds = new [] { "subnetIds" }
}
},
// the properties below are optional
Alias = "alias",
RoleConfiguration = new RoleConfigurationProperty {
SourceRoleArn = "sourceRoleArn",
TargetRoleArn = "targetRoleArn"
},
ScraperLoggingConfiguration = new ScraperLoggingConfigurationProperty {
LoggingDestination = new ScraperLoggingDestinationProperty {
CloudWatchLogs = new CloudWatchLogDestinationProperty {
LogGroupArn = "logGroupArn"
}
},
ScraperComponents = new [] { new ScraperComponentProperty {
Type = "type",
// the properties below are optional
Config = new ComponentConfigProperty {
Options = new Dictionary<string, string> {
{ "optionsKey", "options" }
}
}
} }
},
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnScraper := awscdk.Aws_aps.NewCfnScraper(this, jsii.String("MyCfnScraper"), &CfnScraperProps{
Destination: &DestinationProperty{
AmpConfiguration: &AmpConfigurationProperty{
WorkspaceArn: jsii.String("workspaceArn"),
},
CloudWatchConfiguration: &CloudWatchConfigurationProperty{
DatasetArn: jsii.String("datasetArn"),
},
},
ScrapeConfiguration: &ScrapeConfigurationProperty{
ConfigurationBlob: jsii.String("configurationBlob"),
},
Source: &SourceProperty{
EksConfiguration: &EksConfigurationProperty{
ClusterArn: jsii.String("clusterArn"),
SubnetIds: []*string{
jsii.String("subnetIds"),
},
// the properties below are optional
SecurityGroupIds: []*string{
jsii.String("securityGroupIds"),
},
},
VpcConfiguration: &VpcConfigurationProperty{
SecurityGroupIds: []*string{
jsii.String("securityGroupIds"),
},
SubnetIds: []*string{
jsii.String("subnetIds"),
},
},
},
// the properties below are optional
Alias: jsii.String("alias"),
RoleConfiguration: &RoleConfigurationProperty{
SourceRoleArn: jsii.String("sourceRoleArn"),
TargetRoleArn: jsii.String("targetRoleArn"),
},
ScraperLoggingConfiguration: &ScraperLoggingConfigurationProperty{
LoggingDestination: &ScraperLoggingDestinationProperty{
CloudWatchLogs: &CloudWatchLogDestinationProperty{
LogGroupArn: jsii.String("logGroupArn"),
},
},
ScraperComponents: []interface{}{
&ScraperComponentProperty{
Type: jsii.String("type"),
// the properties below are optional
Config: &ComponentConfigProperty{
Options: map[string]*string{
"optionsKey": jsii.String("options"),
},
},
},
},
},
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
})
Initializer
new CfnScraper(scope: Construct, id: string, props: CfnScraperProps)
CfnScraper(scope: Construct, id: str, props: CfnScraperProps)
new CfnScraper(Construct scope, String id, CfnScraperProps props)
new CfnScraper(Construct scope, string id, CfnScraperProps props)
NewCfnScraper(Scope Construct, Id *string, Props CfnScraperProps)
Construct Props
destinationIResolvable | CfnScraper.DestinationPropertydestinationtyping.Union[IResolvable, DestinationProperty]destinationIResolvableDestinationIResolvableDestinationinterface{}required#roleConfigurationoptionalIResolvable | CfnScraper.RoleConfigurationPropertyrole_configurationoptionaltyping.Union[IResolvable, RoleConfigurationProperty]roleConfigurationoptionalIResolvableRoleConfigurationoptionalIResolvableRoleConfigurationoptionalinterface{}#scrapeConfigurationIResolvable | CfnScraper.ScrapeConfigurationPropertyscrape_configurationtyping.Union[IResolvable, ScrapeConfigurationProperty]scrapeConfigurationIResolvableScrapeConfigurationIResolvableScrapeConfigurationinterface{}required#scraperLoggingConfigurationoptionalIResolvable | CfnScraper.ScraperLoggingConfigurationPropertyscraper_logging_configurationoptionaltyping.Union[IResolvable, ScraperLoggingConfigurationProperty]scraperLoggingConfigurationoptionalIResolvableScraperLoggingConfigurationoptionalIResolvableScraperLoggingConfigurationoptionalinterface{}#sourceIResolvable | CfnScraper.SourcePropertysourcetyping.Union[IResolvable, SourceProperty]sourceIResolvableSourceIResolvableSourceinterface{}required#Properties
aliasmay be undefinedstringaliasmay be undefinedstraliasmay be undefinedStringAliasmay be undefinedstringAliasmay be undefined*string#For example, arn:aws:aps:<region>:123456798012:scraper/s-example1-1234-abcd-5678-ef9012abcd34 .
For example, arn:aws:iam::123456789012:role/service-role/AmazonGrafanaServiceRole-12example .
attrScraperIdstringattr_scraper_idstrattrScraperIdStringAttrScraperIdstringAttrScraperId*stringrequired#For example, s-example1-1234-abcd-5678-ef9012abcd34 .
cdkTagManagerTagManagercdk_tag_managerTagManagercdkTagManagerTagManagerCdkTagManagerTagManagerCdkTagManagerTagManagerrequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#destinationIResolvable | CfnScraper.DestinationPropertydestinationtyping.Union[IResolvable, DestinationProperty]destinationIResolvableDestinationIResolvableDestinationinterface{}required#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
roleConfigurationmay be undefinedIResolvable | CfnScraper.RoleConfigurationPropertyrole_configurationmay be undefinedtyping.Union[IResolvable, RoleConfigurationProperty]roleConfigurationmay be undefinedIResolvableRoleConfigurationmay be undefinedIResolvableRoleConfigurationmay be undefinedinterface{}#scrapeConfigurationIResolvable | CfnScraper.ScrapeConfigurationPropertyscrape_configurationtyping.Union[IResolvable, ScrapeConfigurationProperty]scrapeConfigurationIResolvableScrapeConfigurationIResolvableScrapeConfigurationinterface{}required#scraperLoggingConfigurationmay be undefinedIResolvable | CfnScraper.ScraperLoggingConfigurationPropertyscraper_logging_configurationmay be undefinedtyping.Union[IResolvable, ScraperLoggingConfigurationProperty]scraperLoggingConfigurationmay be undefinedIResolvableScraperLoggingConfigurationmay be undefinedIResolvableScraperLoggingConfigurationmay be undefinedinterface{}#scraperRefScraperReferencescraper_refScraperReferencescraperRefScraperReferenceScraperRefScraperReferenceScraperRefScraperReferencerequired#sourceIResolvable | CfnScraper.SourcePropertysourcetyping.Union[IResolvable, SourceProperty]sourceIResolvableSourceIResolvableSourceinterface{}required#CfnElements must be defined within a stack scope (directly or indirectly).
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForScraper(resource: IScraperRef): string@staticmethod def arn_for_scraper(resource: IScraperRef) -> strpublic static String arnForScraper(IScraperRef resource)public static string ArnForScraper(IScraperRef resource)func ArnForScraper(Resource IScraperRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isCfnScraper(x: any): boolean@staticmethod def is_cfn_scraper(x: Any) -> boolpublic static Boolean isCfnScraper(Object x)public static bool IsCfnScraper(object x)func IsCfnScraper(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.